{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "listing": [
                        {
                            "entryname": "pileups.tsv",
                            "entry": "$(\n  \"sample_id\tpatient_id\tsample_class\tpileup\\n\" +\n  inputs.sample_ids.map(function(sid, i) {\n    if (inputs.sample_classes[i] == 'Tumor') {\n      var pileup = inputs.duplex_pileups[i].path;\n    } else {\n      var pileup = inputs.unfiltered_pileups[i].path;\n    }\n\n    return sid + \"\\t\" +\n      inputs.patient_ids[i] + \"\\t\" +\n      inputs.sample_classes[i] + \"\\t\" +\n      pileup;\n  }).join(\"\\n\")\n)"
                        }
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "types": [
                        {
                            "type": "record",
                            "name": "#collapsing_tools.yaml/run_tools",
                            "fields": [
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/perl_5",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/java_7",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/java_8",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/marianas_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/bioinfo_utils",
                                    "type": "File"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/trimgalore_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/bwa_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/arrg_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/picard_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/gatk_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/abra_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/fx_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#collapsing_tools.yaml/run_tools/waltz_path",
                                    "type": "string"
                                }
                            ]
                        }
                    ],
                    "class": "SchemaDefRequirement"
                }
            ],
            "arguments": [
                "$(inputs.java)",
                "-server",
                "-Xms4g",
                "-Xmx4g",
                "-cp",
                "$(inputs.bioinfo_utils)",
                "org.mskcc.juber.commands.FindHotspotsInNormals",
                "pileups.tsv",
                "$(inputs.hotspot_list)"
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#find_hotspots_in_normals.cwl/bioinfo_utils"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#find_hotspots_in_normals.cwl/duplex_pileups"
                },
                {
                    "type": "File",
                    "id": "#find_hotspots_in_normals.cwl/hotspot_list"
                },
                {
                    "type": "string",
                    "id": "#find_hotspots_in_normals.cwl/java"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#find_hotspots_in_normals.cwl/patient_ids"
                },
                {
                    "type": "#collapsing_tools.yaml/run_tools",
                    "id": "#find_hotspots_in_normals.cwl/run_tools"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#find_hotspots_in_normals.cwl/sample_classes"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#find_hotspots_in_normals.cwl/sample_ids"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#find_hotspots_in_normals.cwl/unfiltered_pileups"
                }
            ],
            "id": "#find_hotspots_in_normals.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "hotspots-in-normals.txt"
                    },
                    "id": "#find_hotspots_in_normals.cwl/hotspots_in_normals_data"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "plot_hotspots_in_normals.r",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.hotspots_in_normals_data)",
                            "writable": false
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#plot_hotspots_in_normals.cwl/hotspots_in_normals_data"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "hotspots_in_normals.pdf"
                    },
                    "id": "#plot_hotspots_in_normals.cwl/hotspots_in_normals_plot"
                }
            ],
            "id": "#plot_hotspots_in_normals.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "print_hotspots_in_normals_table_pdf",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--hotspots_table"
                    },
                    "id": "#print_hotspots_in_normals_table.cwl/table"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "hotspots_in_normals.pdf"
                    },
                    "id": "#print_hotspots_in_normals_table.cwl/hotspots_in_normals_table_pdf"
                }
            ],
            "id": "#print_hotspots_in_normals_table.cwl"
        },
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 2000,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "This tool groups waltz qc files into a single directory\n",
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/all_fp_results"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/combined_qc"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/duplex_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/duplex_pool_a_exon_level"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/duplex_pool_b"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/family_sizes"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/family_types_A"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/family_types_B"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/gender_table"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/qc_tables"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/simplex_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/simplex_pool_a_exon_level"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/simplex_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/standard_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/standard_pool_a_exon_level"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/standard_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/unfiltered_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/unfiltered_pool_a_exon_level"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/unfiltered_pool_b"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/qc_files"
                }
            ],
            "expression": "${\n  var output_files = [];\n\n  output_files.push(inputs.standard_pool_a);\n  output_files.push(inputs.unfiltered_pool_a);\n  output_files.push(inputs.simplex_pool_a);\n  output_files.push(inputs.duplex_pool_a);\n  output_files.push(inputs.standard_pool_b);\n  output_files.push(inputs.unfiltered_pool_b);\n  output_files.push(inputs.simplex_pool_b);\n  output_files.push(inputs.duplex_pool_b);\n\n  output_files.push(inputs.standard_pool_a_exon_level);\n  output_files.push(inputs.unfiltered_pool_a_exon_level);\n  output_files.push(inputs.simplex_pool_a_exon_level);\n  output_files.push(inputs.duplex_pool_a_exon_level);\n\n  output_files.push(inputs.qc_tables);\n  output_files.push(inputs.all_fp_results);\n  output_files.push(inputs.gender_table);\n  output_files.push(inputs.family_sizes);\n  output_files.push(inputs.family_types_A);\n  output_files.push(inputs.family_types_B);\n  output_files.push(inputs.combined_qc);\n\n  return {\n    'qc_files': {\n      'class': 'Directory',\n      'basename': 'QC_Results',\n      'listing': output_files\n    }\n  };\n}\n",
            "id": "#group_qc_files.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "calculate_noise.sh"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": "$(inputs.waltz_directory.listing)"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#calculate_noise.cwl/good_positions_A"
                },
                {
                    "type": "string",
                    "id": "#calculate_noise.cwl/output_dir_name"
                },
                {
                    "type": "Directory",
                    "id": "#calculate_noise.cwl/waltz_directory"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('noise.txt')"
                    },
                    "id": "#calculate_noise.cwl/noise"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('noise-by-substitution.txt')"
                    },
                    "id": "#calculate_noise.cwl/noise_by_substitution"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": ".",
                        "outputEval": "${\n  self[0].basename = inputs.output_dir_name;\n  return self[0]\n}\n"
                    },
                    "id": "#calculate_noise.cwl/waltz_folder_with_noise"
                }
            ],
            "id": "#calculate_noise.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "plot_noise"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--noise_file"
                    },
                    "id": "#plot_noise.cwl/noise"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--noise_by_substitution"
                    },
                    "id": "#plot_noise.cwl/noise_by_substitution_table"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--title_file"
                    },
                    "id": "#plot_noise.cwl/title_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('NoiseAltPercent.pdf')"
                    },
                    "id": "#plot_noise.cwl/noise_alt_percent"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('noise_by_substitution.pdf')"
                    },
                    "id": "#plot_noise.cwl/noise_by_substitution"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('NoiseContributingSites.pdf')"
                    },
                    "id": "#plot_noise.cwl/noise_contributing_sites"
                }
            ],
            "id": "#plot_noise.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000,
                    "coresMin": 1
                }
            ],
            "baseCommand": [
                "aggregate_bam_metrics.sh"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#aggregate_bam_metrics.cwl/output_dir_name"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#aggregate_bam_metrics.cwl/waltz_input_files"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": ".",
                        "outputEval": "${\n  self[0].basename = inputs.output_dir_name;\n  return self[0]\n}\n"
                    },
                    "id": "#aggregate_bam_metrics.cwl/output_dir"
                }
            ],
            "id": "#aggregate_bam_metrics.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "base_quality_plot"
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--picard_metrics_directory"
                    },
                    "id": "#base_quality_plot.cwl/picard_metrics"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "base_quality_plot.pdf"
                    },
                    "id": "#base_quality_plot.cwl/plot"
                }
            ],
            "id": "#base_quality_plot.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "combine_qc_pdfs"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#combine_qc_pdfs.cwl/align_rate"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#combine_qc_pdfs.cwl/average_coverage_exon_level_A"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 11
                    },
                    "id": "#combine_qc_pdfs.cwl/base_quality_plot"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 9
                    },
                    "id": "#combine_qc_pdfs.cwl/cov_and_family_type_A"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 10
                    },
                    "id": "#combine_qc_pdfs.cwl/cov_and_family_type_B"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 8
                    },
                    "id": "#combine_qc_pdfs.cwl/coverage_per_interval"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 13
                    },
                    "id": "#combine_qc_pdfs.cwl/family_sizes_duplex"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 12
                    },
                    "id": "#combine_qc_pdfs.cwl/family_sizes_simplex"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 19
                    },
                    "id": "#combine_qc_pdfs.cwl/fingerprinting_qc"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 6
                    },
                    "id": "#combine_qc_pdfs.cwl/gc_cov_each_sample"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 20
                    },
                    "id": "#combine_qc_pdfs.cwl/gender_check"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 17
                    },
                    "id": "#combine_qc_pdfs.cwl/hotspots_in_normals_plot"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 18
                    },
                    "id": "#combine_qc_pdfs.cwl/hotspots_in_normals_table_pdf"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 7
                    },
                    "id": "#combine_qc_pdfs.cwl/insert_sizes"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 14
                    },
                    "id": "#combine_qc_pdfs.cwl/noise_alt_percent"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 15
                    },
                    "id": "#combine_qc_pdfs.cwl/noise_by_substitution"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 16
                    },
                    "id": "#combine_qc_pdfs.cwl/noise_contributing_sites"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#combine_qc_pdfs.cwl/on_target_rate"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 21
                    },
                    "id": "#combine_qc_pdfs.cwl/pipeline_inputs"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-p"
                    },
                    "id": "#combine_qc_pdfs.cwl/project_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#combine_qc_pdfs.cwl/read_counts"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#combine_qc_pdfs.cwl/title_page"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.pdf"
                    },
                    "id": "#combine_qc_pdfs.cwl/combined_qc"
                }
            ],
            "id": "#combine_qc_pdfs.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "fingerprinting"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--fp_config"
                    },
                    "id": "#fingerprinting.cwl/FP_config_file"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--output_dir"
                    },
                    "id": "#fingerprinting.cwl/output_directory"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--title_file"
                    },
                    "id": "#fingerprinting.cwl/title_file"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--waltz_dir_A"
                    },
                    "id": "#fingerprinting.cwl/waltz_directory_A"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--waltz_dir_A_duplex"
                    },
                    "id": "#fingerprinting.cwl/waltz_directory_A_duplex"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--waltz_dir_B"
                    },
                    "id": "#fingerprinting.cwl/waltz_directory_B"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--waltz_dir_B_duplex"
                    },
                    "id": "#fingerprinting.cwl/waltz_directory_B_duplex"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "./FPResults/FPFigures.pdf"
                    },
                    "id": "#fingerprinting.cwl/FPFigures"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "./FPResults"
                    },
                    "id": "#fingerprinting.cwl/all_fp_results"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "GenderMisMatch.pdf"
                    },
                    "id": "#fingerprinting.cwl/gender_plot"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "MisMatchedGender.txt"
                    },
                    "id": "#fingerprinting.cwl/gender_table"
                }
            ],
            "id": "#fingerprinting.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000,
                    "coresMin": 1
                }
            ],
            "baseCommand": "plots_module.r",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--family_sizes_path"
                    },
                    "id": "#plots_module.cwl/family_sizes"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--family_types_A_path"
                    },
                    "id": "#plots_module.cwl/family_types_A"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--family_types_B_path"
                    },
                    "id": "#plots_module.cwl/family_types_B"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--inputs_yaml_path"
                    },
                    "id": "#plots_module.cwl/inputs_yaml"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--tables_output_dir"
                    },
                    "id": "#plots_module.cwl/tables"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--title_file_path"
                    },
                    "id": "#plots_module.cwl/title_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "align_rate.pdf"
                    },
                    "id": "#plots_module.cwl/align_rate"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "average_coverage_duplex_A_exon.pdf"
                    },
                    "id": "#plots_module.cwl/average_coverage_exon_level_A"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "a_targets_cov_and_family_types.pdf"
                    },
                    "id": "#plots_module.cwl/cov_and_family_type_A"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "b_targets_cov_and_family_types.pdf"
                    },
                    "id": "#plots_module.cwl/cov_and_family_type_B"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "coverage_per_interval.pdf"
                    },
                    "id": "#plots_module.cwl/coverage_per_interval"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family_sizes_all.pdf"
                    },
                    "id": "#plots_module.cwl/family_sizes_all"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family_sizes_duplex.pdf"
                    },
                    "id": "#plots_module.cwl/family_sizes_duplex"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family_sizes_simplex.pdf"
                    },
                    "id": "#plots_module.cwl/family_sizes_simplex"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "gc_cov_each_sample.pdf"
                    },
                    "id": "#plots_module.cwl/gc_cov_each_sample"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "insert_sizes.pdf"
                    },
                    "id": "#plots_module.cwl/insert_sizes"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "on_target_rate.pdf"
                    },
                    "id": "#plots_module.cwl/on_target_rate"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "pipeline_inputs.pdf"
                    },
                    "id": "#plots_module.cwl/pipeline_inputs"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "read_counts.pdf"
                    },
                    "id": "#plots_module.cwl/read_counts"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "title_page.pdf"
                    },
                    "id": "#plots_module.cwl/title_page"
                }
            ],
            "id": "#plots_module.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000,
                    "coresMin": 1
                }
            ],
            "baseCommand": "tables_module",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--duplex_waltz_pool_a"
                    },
                    "id": "#tables_module.cwl/duplex_waltz_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--duplex_waltz_metrics_pool_a_exon_level"
                    },
                    "id": "#tables_module.cwl/duplex_waltz_metrics_pool_a_exon_level"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--duplex_waltz_pool_b"
                    },
                    "id": "#tables_module.cwl/duplex_waltz_metrics_pool_b"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--simplex_waltz_pool_a"
                    },
                    "id": "#tables_module.cwl/simplex_waltz_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--simplex_waltz_metrics_pool_a_exon_level"
                    },
                    "id": "#tables_module.cwl/simplex_waltz_metrics_pool_a_exon_level"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--simplex_waltz_pool_b"
                    },
                    "id": "#tables_module.cwl/simplex_waltz_metrics_pool_b"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--standard_waltz_pool_a"
                    },
                    "id": "#tables_module.cwl/standard_waltz_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--standard_waltz_metrics_pool_a_exon_level"
                    },
                    "id": "#tables_module.cwl/standard_waltz_metrics_pool_a_exon_level"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--standard_waltz_pool_b"
                    },
                    "id": "#tables_module.cwl/standard_waltz_metrics_pool_b"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--unfiltered_waltz_pool_a"
                    },
                    "id": "#tables_module.cwl/unfiltered_waltz_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--unfiltered_waltz_metrics_pool_a_exon_level"
                    },
                    "id": "#tables_module.cwl/unfiltered_waltz_metrics_pool_a_exon_level"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--unfiltered_waltz_pool_b"
                    },
                    "id": "#tables_module.cwl/unfiltered_waltz_metrics_pool_b"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": ".",
                        "outputEval": "${\n  self[0].basename = 'aggregate_tables';\n  return self[0]\n}\n"
                    },
                    "id": "#tables_module.cwl/tables"
                }
            ],
            "id": "#tables_module.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "make_umi_qc_tables.sh"
            ],
            "requirements": [
                {
                    "outdirMax": 300000,
                    "ramMin": 4000,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#make_umi_qc_tables.cwl/A_on_target_positions"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#make_umi_qc_tables.cwl/B_on_target_positions"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#make_umi_qc_tables.cwl/folders"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family-sizes.txt"
                    },
                    "id": "#make_umi_qc_tables.cwl/family_sizes"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family-types-A.txt"
                    },
                    "id": "#make_umi_qc_tables.cwl/family_types_A"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family-types-B.txt"
                    },
                    "id": "#make_umi_qc_tables.cwl/family_types_B"
                }
            ],
            "id": "#make_umi_qc_tables.cwl"
        },
        {
            "class": "Workflow",
            "doc": "This workflow is intended to be used to test the QC module,\nwithout having to run the long waltz step\n",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "types": [
                        {
                            "$import": "#collapsing_tools.yaml/run_tools"
                        }
                    ],
                    "class": "SchemaDefRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/A_on_target_positions"
                },
                {
                    "type": "File",
                    "id": "#main/B_on_target_positions"
                },
                {
                    "type": "File",
                    "id": "#main/FP_config_file"
                },
                {
                    "type": "File",
                    "id": "#main/hotspots"
                },
                {
                    "type": "File",
                    "id": "#main/inputs_yaml"
                },
                {
                    "type": "File",
                    "id": "#main/noise__good_positions_A"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/patient_id"
                },
                {
                    "type": "Directory",
                    "id": "#main/picard_metrics"
                },
                {
                    "type": "string",
                    "id": "#main/project_name"
                },
                {
                    "type": "#collapsing_tools.yaml/run_tools",
                    "id": "#main/run_tools"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/sample_class"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#main/sample_directories"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/sample_id"
                },
                {
                    "type": "File",
                    "id": "#main/title_file"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_duplex_a_exon_level_files"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_duplex_pool_a"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/waltz_duplex_pool_a_pileups"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_duplex_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_simplex_a_exon_level_files"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_simplex_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_simplex_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_standard_a_exon_level_files"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_standard_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_standard_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_unfiltered_a_exon_level_files"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_unfiltered_pool_a"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/waltz_unfiltered_pool_a_pileups"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_unfiltered_pool_b"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputSource": "#main/group_qc_files/qc_files",
                    "id": "#main/combined_qc"
                },
                {
                    "type": "File",
                    "outputSource": "#main/find_hotspots_in_normals/hotspots_in_normals_data",
                    "id": "#main/hotspots_in_normals_data"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/main_tables_module/tables",
                    "id": "#main/tables"
                }
            ],
            "steps": [
                {
                    "run": "#base_quality_plot.cwl",
                    "in": [
                        {
                            "source": "#main/picard_metrics",
                            "id": "#main/base_quality_plot/picard_metrics"
                        }
                    ],
                    "out": [
                        "#main/base_quality_plot/plot"
                    ],
                    "id": "#main/base_quality_plot"
                },
                {
                    "run": "#combine_qc_pdfs.cwl",
                    "in": [
                        {
                            "source": "#main/main_plots_module/align_rate",
                            "id": "#main/combine_qc/align_rate"
                        },
                        {
                            "source": "#main/main_plots_module/average_coverage_exon_level_A",
                            "id": "#main/combine_qc/average_coverage_exon_level_A"
                        },
                        {
                            "source": "#main/base_quality_plot/plot",
                            "id": "#main/combine_qc/base_quality_plot"
                        },
                        {
                            "source": "#main/main_plots_module/cov_and_family_type_A",
                            "id": "#main/combine_qc/cov_and_family_type_A"
                        },
                        {
                            "source": "#main/main_plots_module/cov_and_family_type_B",
                            "id": "#main/combine_qc/cov_and_family_type_B"
                        },
                        {
                            "source": "#main/main_plots_module/coverage_per_interval",
                            "id": "#main/combine_qc/coverage_per_interval"
                        },
                        {
                            "source": "#main/main_plots_module/family_sizes_duplex",
                            "id": "#main/combine_qc/family_sizes_duplex"
                        },
                        {
                            "source": "#main/main_plots_module/family_sizes_simplex",
                            "id": "#main/combine_qc/family_sizes_simplex"
                        },
                        {
                            "source": "#main/fingerprinting/FPFigures",
                            "id": "#main/combine_qc/fingerprinting_qc"
                        },
                        {
                            "source": "#main/main_plots_module/gc_cov_each_sample",
                            "id": "#main/combine_qc/gc_cov_each_sample"
                        },
                        {
                            "source": "#main/fingerprinting/gender_plot",
                            "id": "#main/combine_qc/gender_check"
                        },
                        {
                            "source": "#main/find_hotspots_in_normals/hotspots_in_normals_plot",
                            "id": "#main/combine_qc/hotspots_in_normals_plot"
                        },
                        {
                            "source": "#main/find_hotspots_in_normals/hotspots_in_normals_table_pdf",
                            "id": "#main/combine_qc/hotspots_in_normals_table_pdf"
                        },
                        {
                            "source": "#main/main_plots_module/insert_sizes",
                            "id": "#main/combine_qc/insert_sizes"
                        },
                        {
                            "source": "#main/duplex_noise_plots_A/noise_alt_percent",
                            "id": "#main/combine_qc/noise_alt_percent"
                        },
                        {
                            "source": "#main/duplex_noise_plots_A/noise_by_substitution",
                            "id": "#main/combine_qc/noise_by_substitution"
                        },
                        {
                            "source": "#main/duplex_noise_plots_A/noise_contributing_sites",
                            "id": "#main/combine_qc/noise_contributing_sites"
                        },
                        {
                            "source": "#main/main_plots_module/on_target_rate",
                            "id": "#main/combine_qc/on_target_rate"
                        },
                        {
                            "source": "#main/main_plots_module/pipeline_inputs",
                            "id": "#main/combine_qc/pipeline_inputs"
                        },
                        {
                            "source": "#main/project_name",
                            "id": "#main/combine_qc/project_name"
                        },
                        {
                            "source": "#main/main_plots_module/read_counts",
                            "id": "#main/combine_qc/read_counts"
                        },
                        {
                            "source": "#main/main_plots_module/title_page",
                            "id": "#main/combine_qc/title_page"
                        }
                    ],
                    "out": [
                        "#main/combine_qc/combined_qc"
                    ],
                    "id": "#main/combine_qc"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_duplex_pool_a')",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_a/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_duplex_pool_a",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_a/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/duplex_aggregate_bam_metrics_pool_a/output_dir"
                    ],
                    "id": "#main/duplex_aggregate_bam_metrics_pool_a"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_duplex_a_exon_level_files')",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_a_exon_level/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_duplex_a_exon_level_files",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_a_exon_level/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/duplex_aggregate_bam_metrics_pool_a_exon_level/output_dir"
                    ],
                    "id": "#main/duplex_aggregate_bam_metrics_pool_a_exon_level"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_duplex_pool_b')",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_b/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_duplex_pool_b",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_b/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/duplex_aggregate_bam_metrics_pool_b/output_dir"
                    ],
                    "id": "#main/duplex_aggregate_bam_metrics_pool_b"
                },
                {
                    "run": "#plot_noise.cwl",
                    "in": [
                        {
                            "source": "#main/duplex_noise_tables_A/noise",
                            "id": "#main/duplex_noise_plots_A/noise"
                        },
                        {
                            "source": "#main/duplex_noise_tables_A/noise_by_substitution",
                            "id": "#main/duplex_noise_plots_A/noise_by_substitution_table"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/duplex_noise_plots_A/title_file"
                        }
                    ],
                    "out": [
                        "#main/duplex_noise_plots_A/noise_alt_percent",
                        "#main/duplex_noise_plots_A/noise_contributing_sites",
                        "#main/duplex_noise_plots_A/noise_by_substitution"
                    ],
                    "id": "#main/duplex_noise_plots_A"
                },
                {
                    "run": "#calculate_noise.cwl",
                    "in": [
                        {
                            "source": "#main/noise__good_positions_A",
                            "id": "#main/duplex_noise_tables_A/good_positions_A"
                        },
                        {
                            "valueFrom": "$('waltz_duplex_pool_a')",
                            "id": "#main/duplex_noise_tables_A/output_dir_name"
                        },
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/duplex_noise_tables_A/waltz_directory"
                        }
                    ],
                    "out": [
                        "#main/duplex_noise_tables_A/noise",
                        "#main/duplex_noise_tables_A/noise_by_substitution",
                        "#main/duplex_noise_tables_A/waltz_folder_with_noise"
                    ],
                    "id": "#main/duplex_noise_tables_A"
                },
                {
                    "run": "#find_hotspots_in_normals.cwl_2",
                    "in": [
                        {
                            "source": "#main/waltz_duplex_pool_a_pileups",
                            "id": "#main/find_hotspots_in_normals/duplex_pileups"
                        },
                        {
                            "source": "#main/hotspots",
                            "id": "#main/find_hotspots_in_normals/hotspot_list"
                        },
                        {
                            "source": "#main/patient_id",
                            "id": "#main/find_hotspots_in_normals/patient_ids"
                        },
                        {
                            "source": "#main/run_tools",
                            "id": "#main/find_hotspots_in_normals/run_tools"
                        },
                        {
                            "source": "#main/sample_class",
                            "id": "#main/find_hotspots_in_normals/sample_classes"
                        },
                        {
                            "source": "#main/sample_id",
                            "id": "#main/find_hotspots_in_normals/sample_ids"
                        },
                        {
                            "source": "#main/waltz_unfiltered_pool_a_pileups",
                            "id": "#main/find_hotspots_in_normals/unfiltered_pileups"
                        }
                    ],
                    "out": [
                        "#main/find_hotspots_in_normals/hotspots_in_normals_data",
                        "#main/find_hotspots_in_normals/hotspots_in_normals_table_pdf",
                        "#main/find_hotspots_in_normals/hotspots_in_normals_plot"
                    ],
                    "id": "#main/find_hotspots_in_normals"
                },
                {
                    "run": "#fingerprinting.cwl",
                    "in": [
                        {
                            "source": "#main/FP_config_file",
                            "id": "#main/fingerprinting/FP_config_file"
                        },
                        {
                            "valueFrom": "${return '.'}",
                            "id": "#main/fingerprinting/output_directory"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/fingerprinting/title_file"
                        },
                        {
                            "source": "#main/waltz_unfiltered_pool_a",
                            "id": "#main/fingerprinting/waltz_directory_A"
                        },
                        {
                            "source": "#main/waltz_duplex_pool_a",
                            "id": "#main/fingerprinting/waltz_directory_A_duplex"
                        },
                        {
                            "source": "#main/waltz_unfiltered_pool_b",
                            "id": "#main/fingerprinting/waltz_directory_B"
                        },
                        {
                            "source": "#main/waltz_duplex_pool_b",
                            "id": "#main/fingerprinting/waltz_directory_B_duplex"
                        }
                    ],
                    "out": [
                        "#main/fingerprinting/all_fp_results",
                        "#main/fingerprinting/FPFigures",
                        "#main/fingerprinting/gender_table",
                        "#main/fingerprinting/gender_plot"
                    ],
                    "id": "#main/fingerprinting"
                },
                {
                    "run": "#group_qc_files.cwl",
                    "in": [
                        {
                            "source": "#main/fingerprinting/all_fp_results",
                            "id": "#main/group_qc_files/all_fp_results"
                        },
                        {
                            "source": "#main/combine_qc/combined_qc",
                            "id": "#main/group_qc_files/combined_qc"
                        },
                        {
                            "source": "#main/duplex_noise_tables_A/waltz_folder_with_noise",
                            "id": "#main/group_qc_files/duplex_pool_a"
                        },
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_a_exon_level/output_dir",
                            "id": "#main/group_qc_files/duplex_pool_a_exon_level"
                        },
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/group_qc_files/duplex_pool_b"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_sizes",
                            "id": "#main/group_qc_files/family_sizes"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_types_A",
                            "id": "#main/group_qc_files/family_types_A"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_types_B",
                            "id": "#main/group_qc_files/family_types_B"
                        },
                        {
                            "source": "#main/fingerprinting/gender_table",
                            "id": "#main/group_qc_files/gender_table"
                        },
                        {
                            "source": "#main/main_tables_module/tables",
                            "id": "#main/group_qc_files/qc_tables"
                        },
                        {
                            "source": "#main/simplex_noise_tables_A/waltz_folder_with_noise",
                            "id": "#main/group_qc_files/simplex_pool_a"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_a_exon_level/output_dir",
                            "id": "#main/group_qc_files/simplex_pool_a_exon_level"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/group_qc_files/simplex_pool_b"
                        },
                        {
                            "source": "#main/standard_noise_tables_A/waltz_folder_with_noise",
                            "id": "#main/group_qc_files/standard_pool_a"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_a_exon_level/output_dir",
                            "id": "#main/group_qc_files/standard_pool_a_exon_level"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/group_qc_files/standard_pool_b"
                        },
                        {
                            "source": "#main/unfiltered_noise_tables_A/waltz_folder_with_noise",
                            "id": "#main/group_qc_files/unfiltered_pool_a"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_a_exon_level/output_dir",
                            "id": "#main/group_qc_files/unfiltered_pool_a_exon_level"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/group_qc_files/unfiltered_pool_b"
                        }
                    ],
                    "out": [
                        "#main/group_qc_files/qc_files"
                    ],
                    "id": "#main/group_qc_files"
                },
                {
                    "run": "#plots_module.cwl",
                    "in": [
                        {
                            "source": "#main/umi_qc_tables/family_sizes",
                            "id": "#main/main_plots_module/family_sizes"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_types_A",
                            "id": "#main/main_plots_module/family_types_A"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_types_B",
                            "id": "#main/main_plots_module/family_types_B"
                        },
                        {
                            "source": "#main/inputs_yaml",
                            "id": "#main/main_plots_module/inputs_yaml"
                        },
                        {
                            "source": "#main/main_tables_module/tables",
                            "id": "#main/main_plots_module/tables"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/main_plots_module/title_file"
                        }
                    ],
                    "out": [
                        "#main/main_plots_module/read_counts",
                        "#main/main_plots_module/align_rate",
                        "#main/main_plots_module/on_target_rate",
                        "#main/main_plots_module/gc_cov_each_sample",
                        "#main/main_plots_module/insert_sizes",
                        "#main/main_plots_module/coverage_per_interval",
                        "#main/main_plots_module/title_page",
                        "#main/main_plots_module/cov_and_family_type_A",
                        "#main/main_plots_module/cov_and_family_type_B",
                        "#main/main_plots_module/family_sizes_all",
                        "#main/main_plots_module/family_sizes_simplex",
                        "#main/main_plots_module/family_sizes_duplex",
                        "#main/main_plots_module/pipeline_inputs",
                        "#main/main_plots_module/average_coverage_exon_level_A"
                    ],
                    "id": "#main/main_plots_module"
                },
                {
                    "run": "#tables_module.cwl",
                    "in": [
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/main_tables_module/duplex_waltz_metrics_pool_a"
                        },
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_a_exon_level/output_dir",
                            "id": "#main/main_tables_module/duplex_waltz_metrics_pool_a_exon_level"
                        },
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/main_tables_module/duplex_waltz_metrics_pool_b"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/main_tables_module/simplex_waltz_metrics_pool_a"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_a_exon_level/output_dir",
                            "id": "#main/main_tables_module/simplex_waltz_metrics_pool_a_exon_level"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/main_tables_module/simplex_waltz_metrics_pool_b"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/main_tables_module/standard_waltz_metrics_pool_a"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_a_exon_level/output_dir",
                            "id": "#main/main_tables_module/standard_waltz_metrics_pool_a_exon_level"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/main_tables_module/standard_waltz_metrics_pool_b"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/main_tables_module/unfiltered_waltz_metrics_pool_a"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_a_exon_level/output_dir",
                            "id": "#main/main_tables_module/unfiltered_waltz_metrics_pool_a_exon_level"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/main_tables_module/unfiltered_waltz_metrics_pool_b"
                        }
                    ],
                    "out": [
                        "#main/main_tables_module/tables"
                    ],
                    "id": "#main/main_tables_module"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_simplex_pool_a')",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_a/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_simplex_pool_a",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_a/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/simplex_aggregate_bam_metrics_pool_a/output_dir"
                    ],
                    "id": "#main/simplex_aggregate_bam_metrics_pool_a"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_simplex_a_exon_level_files')",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_a_exon_level/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_simplex_a_exon_level_files",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_a_exon_level/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/simplex_aggregate_bam_metrics_pool_a_exon_level/output_dir"
                    ],
                    "id": "#main/simplex_aggregate_bam_metrics_pool_a_exon_level"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_simplex_pool_b')",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_b/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_simplex_pool_b",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_b/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/simplex_aggregate_bam_metrics_pool_b/output_dir"
                    ],
                    "id": "#main/simplex_aggregate_bam_metrics_pool_b"
                },
                {
                    "run": "#plot_noise.cwl",
                    "in": [
                        {
                            "source": "#main/simplex_noise_tables_A/noise",
                            "id": "#main/simplex_noise_plots_A/noise"
                        },
                        {
                            "source": "#main/simplex_noise_tables_A/noise_by_substitution",
                            "id": "#main/simplex_noise_plots_A/noise_by_substitution_table"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/simplex_noise_plots_A/title_file"
                        }
                    ],
                    "out": [
                        "#main/simplex_noise_plots_A/noise_alt_percent",
                        "#main/simplex_noise_plots_A/noise_contributing_sites"
                    ],
                    "id": "#main/simplex_noise_plots_A"
                },
                {
                    "run": "#calculate_noise.cwl",
                    "in": [
                        {
                            "source": "#main/noise__good_positions_A",
                            "id": "#main/simplex_noise_tables_A/good_positions_A"
                        },
                        {
                            "valueFrom": "$('waltz_simplex_pool_a')",
                            "id": "#main/simplex_noise_tables_A/output_dir_name"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/simplex_noise_tables_A/waltz_directory"
                        }
                    ],
                    "out": [
                        "#main/simplex_noise_tables_A/noise",
                        "#main/simplex_noise_tables_A/noise_by_substitution",
                        "#main/simplex_noise_tables_A/waltz_folder_with_noise"
                    ],
                    "id": "#main/simplex_noise_tables_A"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_standard_pool_a')",
                            "id": "#main/standard_aggregate_bam_metrics_pool_a/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_standard_pool_a",
                            "id": "#main/standard_aggregate_bam_metrics_pool_a/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/standard_aggregate_bam_metrics_pool_a/output_dir"
                    ],
                    "id": "#main/standard_aggregate_bam_metrics_pool_a"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_standard_a_exon_level_files')",
                            "id": "#main/standard_aggregate_bam_metrics_pool_a_exon_level/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_standard_a_exon_level_files",
                            "id": "#main/standard_aggregate_bam_metrics_pool_a_exon_level/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/standard_aggregate_bam_metrics_pool_a_exon_level/output_dir"
                    ],
                    "id": "#main/standard_aggregate_bam_metrics_pool_a_exon_level"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_standard_pool_b')",
                            "id": "#main/standard_aggregate_bam_metrics_pool_b/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_standard_pool_b",
                            "id": "#main/standard_aggregate_bam_metrics_pool_b/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/standard_aggregate_bam_metrics_pool_b/output_dir"
                    ],
                    "id": "#main/standard_aggregate_bam_metrics_pool_b"
                },
                {
                    "run": "#plot_noise.cwl",
                    "in": [
                        {
                            "source": "#main/standard_noise_tables_A/noise",
                            "id": "#main/standard_noise_plots_A/noise"
                        },
                        {
                            "source": "#main/standard_noise_tables_A/noise_by_substitution",
                            "id": "#main/standard_noise_plots_A/noise_by_substitution_table"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/standard_noise_plots_A/title_file"
                        }
                    ],
                    "out": [
                        "#main/standard_noise_plots_A/noise_alt_percent",
                        "#main/standard_noise_plots_A/noise_contributing_sites"
                    ],
                    "id": "#main/standard_noise_plots_A"
                },
                {
                    "run": "#calculate_noise.cwl",
                    "in": [
                        {
                            "source": "#main/noise__good_positions_A",
                            "id": "#main/standard_noise_tables_A/good_positions_A"
                        },
                        {
                            "valueFrom": "$('waltz_standard_pool_a')",
                            "id": "#main/standard_noise_tables_A/output_dir_name"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/standard_noise_tables_A/waltz_directory"
                        }
                    ],
                    "out": [
                        "#main/standard_noise_tables_A/noise",
                        "#main/standard_noise_tables_A/noise_by_substitution",
                        "#main/standard_noise_tables_A/waltz_folder_with_noise"
                    ],
                    "id": "#main/standard_noise_tables_A"
                },
                {
                    "run": "#make_umi_qc_tables.cwl",
                    "in": [
                        {
                            "source": "#main/A_on_target_positions",
                            "id": "#main/umi_qc_tables/A_on_target_positions"
                        },
                        {
                            "source": "#main/B_on_target_positions",
                            "id": "#main/umi_qc_tables/B_on_target_positions"
                        },
                        {
                            "source": "#main/sample_directories",
                            "id": "#main/umi_qc_tables/folders"
                        }
                    ],
                    "out": [
                        "#main/umi_qc_tables/family_sizes",
                        "#main/umi_qc_tables/family_types_A",
                        "#main/umi_qc_tables/family_types_B"
                    ],
                    "id": "#main/umi_qc_tables"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_unfiltered_pool_a')",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_a/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_unfiltered_pool_a",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_a/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/unfiltered_aggregate_bam_metrics_pool_a/output_dir"
                    ],
                    "id": "#main/unfiltered_aggregate_bam_metrics_pool_a"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_unfiltered_a_exon_level_files')",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_a_exon_level/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_unfiltered_a_exon_level_files",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_a_exon_level/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/unfiltered_aggregate_bam_metrics_pool_a_exon_level/output_dir"
                    ],
                    "id": "#main/unfiltered_aggregate_bam_metrics_pool_a_exon_level"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_unfiltered_pool_b')",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_b/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_unfiltered_pool_b",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_b/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/unfiltered_aggregate_bam_metrics_pool_b/output_dir"
                    ],
                    "id": "#main/unfiltered_aggregate_bam_metrics_pool_b"
                },
                {
                    "run": "#plot_noise.cwl",
                    "in": [
                        {
                            "source": "#main/unfiltered_noise_tables_A/noise",
                            "id": "#main/unfiltered_noise_plots_A/noise"
                        },
                        {
                            "source": "#main/unfiltered_noise_tables_A/noise_by_substitution",
                            "id": "#main/unfiltered_noise_plots_A/noise_by_substitution_table"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/unfiltered_noise_plots_A/title_file"
                        }
                    ],
                    "out": [
                        "#main/unfiltered_noise_plots_A/noise_alt_percent",
                        "#main/unfiltered_noise_plots_A/noise_contributing_sites"
                    ],
                    "id": "#main/unfiltered_noise_plots_A"
                },
                {
                    "run": "#calculate_noise.cwl",
                    "in": [
                        {
                            "source": "#main/noise__good_positions_A",
                            "id": "#main/unfiltered_noise_tables_A/good_positions_A"
                        },
                        {
                            "valueFrom": "$('waltz_unfiltered_pool_a')",
                            "id": "#main/unfiltered_noise_tables_A/output_dir_name"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/unfiltered_noise_tables_A/waltz_directory"
                        }
                    ],
                    "out": [
                        "#main/unfiltered_noise_tables_A/noise",
                        "#main/unfiltered_noise_tables_A/noise_by_substitution",
                        "#main/unfiltered_noise_tables_A/waltz_folder_with_noise"
                    ],
                    "id": "#main/unfiltered_noise_tables_A"
                }
            ],
            "id": "#main"
        },
        {
            "class": "Workflow",
            "doc": "Workflow to find hotspot VAFs from duplex (for Tumor sample) and unfiltered (for Normal sample) pileups.\n\nThese inputs are all required to be sorted in the same order:\n\nsample_ids\npatient_ids\nsample_classes\nunfiltered_pileups\nduplex_pileups\n",
            "requirements": [
                {
                    "types": [
                        {
                            "$import": "#collapsing_tools.yaml/run_tools"
                        }
                    ],
                    "class": "SchemaDefRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#find_hotspots_in_normals.cwl_2/duplex_pileups"
                },
                {
                    "type": "File",
                    "id": "#find_hotspots_in_normals.cwl_2/hotspot_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#find_hotspots_in_normals.cwl_2/patient_ids"
                },
                {
                    "type": "#collapsing_tools.yaml/run_tools",
                    "id": "#find_hotspots_in_normals.cwl_2/run_tools"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#find_hotspots_in_normals.cwl_2/sample_classes"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#find_hotspots_in_normals.cwl_2/sample_ids"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#find_hotspots_in_normals.cwl_2/unfiltered_pileups"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/hotspots_in_normals_data",
                    "id": "#find_hotspots_in_normals.cwl_2/hotspots_in_normals_data"
                },
                {
                    "type": "File",
                    "outputSource": "#find_hotspots_in_normals.cwl_2/plot_hotspots_in_normals/hotspots_in_normals_plot",
                    "id": "#find_hotspots_in_normals.cwl_2/hotspots_in_normals_plot"
                },
                {
                    "type": "File",
                    "outputSource": "#find_hotspots_in_normals.cwl_2/print_hotspots_in_normals_table/hotspots_in_normals_table_pdf",
                    "id": "#find_hotspots_in_normals.cwl_2/hotspots_in_normals_table_pdf"
                }
            ],
            "steps": [
                {
                    "run": "#find_hotspots_in_normals.cwl",
                    "in": [
                        {
                            "valueFrom": "$(inputs.run_tools.bioinfo_utils)",
                            "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/bioinfo_utils"
                        },
                        {
                            "source": "#find_hotspots_in_normals.cwl_2/duplex_pileups",
                            "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/duplex_pileups"
                        },
                        {
                            "source": "#find_hotspots_in_normals.cwl_2/hotspot_list",
                            "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/hotspot_list"
                        },
                        {
                            "valueFrom": "$(inputs.run_tools.java_8)",
                            "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/java"
                        },
                        {
                            "source": "#find_hotspots_in_normals.cwl_2/patient_ids",
                            "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/patient_ids"
                        },
                        {
                            "source": "#find_hotspots_in_normals.cwl_2/run_tools",
                            "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/run_tools"
                        },
                        {
                            "source": "#find_hotspots_in_normals.cwl_2/sample_classes",
                            "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/sample_classes"
                        },
                        {
                            "source": "#find_hotspots_in_normals.cwl_2/sample_ids",
                            "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/sample_ids"
                        },
                        {
                            "source": "#find_hotspots_in_normals.cwl_2/unfiltered_pileups",
                            "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/unfiltered_pileups"
                        }
                    ],
                    "out": [
                        "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/hotspots_in_normals_data"
                    ],
                    "id": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals"
                },
                {
                    "run": "#plot_hotspots_in_normals.cwl",
                    "in": [
                        {
                            "source": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/hotspots_in_normals_data",
                            "id": "#find_hotspots_in_normals.cwl_2/plot_hotspots_in_normals/hotspots_in_normals_data"
                        }
                    ],
                    "out": [
                        "#find_hotspots_in_normals.cwl_2/plot_hotspots_in_normals/hotspots_in_normals_plot"
                    ],
                    "id": "#find_hotspots_in_normals.cwl_2/plot_hotspots_in_normals"
                },
                {
                    "run": "#print_hotspots_in_normals_table.cwl",
                    "in": [
                        {
                            "source": "#find_hotspots_in_normals.cwl_2/find_hotspots_in_normals/hotspots_in_normals_data",
                            "id": "#find_hotspots_in_normals.cwl_2/print_hotspots_in_normals_table/table"
                        }
                    ],
                    "out": [
                        "#find_hotspots_in_normals.cwl_2/print_hotspots_in_normals_table/hotspots_in_normals_table_pdf"
                    ],
                    "id": "#find_hotspots_in_normals.cwl_2/print_hotspots_in_normals_table"
                }
            ],
            "id": "#find_hotspots_in_normals.cwl_2"
        }
    ],
    "cwlVersion": "v1.0"
}
